// This is a library collection of stuff I keep re-writing!

/*
  Add MovieClip "_color" property like "_alpha", "_rotation", etc.
*/
MovieClip.prototype.addProperty(
  '_color',
  function(){ return new Color(this).getRGB(); },
  function(rgb) { new Color(this).setRGB(rgb); }
);

// Adjusts an octal rgb value to the percentage specified, and limits min/max
_global.ScaleColourBrightness = function(octRGB, pc){
  //trace(">>octRGB"+octRGB);
  // have to split to threshold each compontent
  var r = (octRGB & 0xFF0000) / 0x010000;
  var g = (octRGB & 0x00FF00) / 0x000100;
  var b = (octRGB & 0x0000FF);
  //trace("r="+r+" g="+g+" b="+b);
  r = Math.min(255, Math.max(0, Math.floor(r*pc/100)));
  g = Math.min(255, Math.max(0, Math.floor(g*pc/100)));
  b = Math.min(255, Math.max(0, Math.floor(b*pc/100)));
  //trace("r="+r+" g="+g+" b="+b);
  rgb = r * 0x10000 + g * 0x100 + b;
  //trace("<<rgb"+rgb);
  return rgb;
}

// TRACING & PROFILING --------------------------------------------------------
// Debug tracing
_global.dtrace = function(s){
  trace(s);
  _root.sDebug += s+"\n";
}
_global.dtrace_clear = function(){
  _root.sDebug = "";
}
// optimisation profiling functions.
_global.g_sDateLog = "";
_global.dlog = function(o,s){
  var g_date = new Date();
  _global.g_sDateLog += "\n"+ g_date.getMinutes() +":"+ g_date.getSeconds() +"."+ g_date.getMilliseconds() + " - "+ o+" "+s;
  delete g_date;
}
_global.dump_dlog = function(){
  trace(_global.g_sDateLog);
  _global.g_sDateLog = "";
}

// Key Codes ------------------------------------------------------------------

// Alpha keys
_global.KEY_A = 65;
_global.KEY_B = 66;
_global.KEY_C = 67;
_global.KEY_D = 68;
_global.KEY_E = 69;
_global.KEY_F = 70;
_global.KEY_G = 71;
_global.KEY_H = 72;
_global.KEY_I = 73;
_global.KEY_J = 74;
_global.KEY_K = 75;
_global.KEY_L = 76;
_global.KEY_M = 77;
_global.KEY_N = 78;
_global.KEY_O = 79;
_global.KEY_P = 80;
_global.KEY_Q = 81;
_global.KEY_R = 82;
_global.KEY_S = 83;
_global.KEY_T = 84;
_global.KEY_U = 85;
_global.KEY_V = 86;
_global.KEY_W = 87;
_global.KEY_X = 88;
_global.KEY_Y = 89;
_global.KEY_Z = 90;
// Main numbers
_global.KEY_0 = 48;
_global.KEY_1 = 49;
_global.KEY_2 = 50;
_global.KEY_3 = 51;
_global.KEY_4 = 52;
_global.KEY_5 = 53;
_global.KEY_6 = 54;
_global.KEY_7 = 55;
_global.KEY_8 = 56;
_global.KEY_9 = 57;
// Keypad
_global.KEY_NUMBPAD0 = 96 ;
_global.KEY_NUMBPAD1 = 97 ;
_global.KEY_NUMBPAD2 = 98 ;
_global.KEY_NUMBPAD3 = 99 ;
_global.KEY_NUMBPAD4 = 100;
_global.KEY_NUMBPAD5 = 101;
_global.KEY_NUMBPAD6 = 102;
_global.KEY_NUMBPAD7 = 103;
_global.KEY_NUMBPAD8 = 104;
_global.KEY_NUMBPAD9 = 105;
_global.KEY_MULTIPLY = 106;
_global.KEY_ADD      = 107;
_global.KEY_ENTER    = 108;
_global.KEY_SUBTRACT = 109;
_global.KEY_DECIMAL  = 110;
_global.KEY_DIVIDE   = 111;
// Functional keys
_global.KEY_BACKSPACE   = 8  ;
_global.KEY_TAB         = 9  ;
_global.KEY_CLEAR       = 12 ;
_global.KEY_ENTER       = 13 ;
_global.KEY_SHIFT       = 16 ;
_global.KEY_CONTROL     = 17 ;
_global.KEY_ALT         = 18 ;
_global.KEY_CAPSLOCK    = 20 ;
_global.KEY_ESC         = 27 ;
_global.KEY_SPACE       = 32;
_global.KEY_SPACEBAR    = 32 ;
_global.KEY_PAGEUP      = 33 ;
_global.KEY_PAGEDOWN    = 34 ;
_global.KEY_END         = 35 ;
_global.KEY_HOME        = 36 ;
_global.KEY_LEFTARROW   = 37 ;
_global.KEY_UPARROW     = 38 ;
_global.KEY_RIGHTARROW  = 39 ;
_global.KEY_DOWNARROW   = 40 ;
_global.KEY_INSERT      = 45 ;
_global.KEY_DELETE      = 46 ;
_global.KEY_HELP        = 47 ;
_global.KEY_NUMLOCK     = 144;
// Punctuations keys
_global.KEY_COMMA       = 186;
_global.KEY_COLON       = 186;
_global.KEY_EQUALS      = 187;
_global.KEY_PLUS        = 187;
_global.KEY_MINUS       = 189;
_global.KEY_UNDERSCORE  = 189;
_global.KEY_FORSLASH    = 191;
_global.KEY_QUESTION    = 191;
_global.KEY_BACKTICK    = 192;
_global.KEY_TILDE       = 192;
_global.KEY_LEFTBRACKET = 219;
_global.KEY_LEFTCURLY   = 219;
_global.KEY_BACKSLASH   = 220;
_global.KEY_PIPE        = 220;
_global.KEY_RIGHTBRACE  = 221;
_global.KEY_RIGHTCURLEY = 221;
_global.KEY_QUOTES      = 222;
_global.KEY_APOS        = 222;

// F Keys
_global.KEY_F1 = 112;
_global.KEY_F2 = 113;
_global.KEY_F3 = 114;
_global.KEY_F4 = 115;
_global.KEY_F5 = 116;
_global.KEY_F6 = 117;
_global.KEY_F7 = 118;
_global.KEY_F8 = 119;
_global.KEY_F9 = 120;
_global.KEY_F10 = 121;
_global.KEY_F11 = 122;
_global.KEY_F12 = 123;